/* $Id: id_attrs.h,v 1.4 2023/03/28 04:22:47 leavens Exp $ */
#ifndef _ID_ATTRS_H
#define _ID_ATTRS_H
#include "token.h"
#include "file_location.h"
#include "machine_types.h"
#include "type_attrs.h"

// attributes of identifiers in the symbol table
typedef struct {
    // file_loc is the source file location of the identifier's declaration
    file_location file_loc;
    var_type vt;  // type (for a variable)
    unsigned int loc_offset; // offset from beginning of scope in AR
} id_attrs;

// Return a freshly allocated id_attrs struct
// with the given file location and the rest of the fields uninitialized.
// If there is no space, bail with an error message,
// so this should never return NULL.
extern id_attrs *id_attrs_start(file_location floc);

// Return a freshly allocated id_attrs struct
// with token t, var_type vt, and offset ofst.
// If there is no space, bail with an error message,
// so this should never return NULL.
extern id_attrs *id_attrs_loc_create(file_location floc, var_type vt,
			   	     unsigned int ofst);

#endif
