/* $Id: machine_types.h,v 1.3 2023/03/29 01:43:50 leavens Exp $ */
#ifndef _MACHINE_TYPES_H
#define _MACHINE_TYPES_H
#include <stdio.h>

typedef enum {int_type, float_type} word_type;

// words for this machine
typedef struct word_s {
    word_type type_tag;
    union word_u {
	int i;
	float f;
    } data;
} word;

// addresses for this machine
typedef unsigned int address;

// number of words used by call instruction
#define LINKS_SIZE 3

// Requires: out is open for writing
// Print to out the word w using format "%-5d" or "%-5f"
// as appropriate for the type tag
extern void word_print(FILE *out, word w);

// Return the int as a word
extern word word_from_int(int i);

// Return the float as a word
extern word word_from_float(float f);

// Return the word as an integer, checking the type tag
extern int word_as_int(word w);

// Return the word as an integer,
// rounding if it was a float
extern int word2int(word w);

// Return the word as a float, checking the type tag
extern float word_as_float(word w);

// Return the word as a float,
// extending an int to a float if need be
float word2float(word w);

#endif
