/* $Id: token.h,v 1.6 2023/03/29 20:46:56 leavens Exp $ */
#ifndef _TOKEN_H
#define _TOKEN_H
#include "machine_types.h"

#define MAX_IDENT_LENGTH 255

// types of tokens
typedef enum {
    floatsym, semisym, boolsym, becomessym, commasym,
    lcurlysym, rcurlysym, identsym, assignsym, ifsym,
    lparensym, rparensym, readsym, writesym, exclaimsym,
    eqeqsym, neqsym, ltsym, leqsym, plussym, minussym,
    multsym, divsym, numbersym, eofsym
} token_type;

// information about each token
typedef struct token {
    token_type typ;
    const char *filename;
    unsigned int line;
    unsigned int column;
    char *text; // non-NULL, if applicable
    word value; // when typ==numbersym, its value
} token;

// Return the name of the token_type enum
// corresponding to the given token_type value
extern const char *ttyp2str(token_type ttyp);

#endif
